<bugID>877339<Summary>Allow createWidget to create different types of widgets</Summary><Description>As far as I know, currently `createWidget` takes only two `type`: "button" and "view". This is not enough, especially for jetpack, if we want to use the new API for the new UI Components.

As Unfocused said here:

https://bugzilla.mozilla.org/show_bug.cgi?id=870897#c3

It would be nice having also "toggle button" and a "custom" type at least, so that we can cover all our needs.

Also, in according to UX mockup, the createWidget API should be able to create a Widget with a "badge" (see https://github.com/mozilla/addon-sdk/wiki/JEP-Navbar-Buttons#badge), where should be possible change text and (background) color. In future iteration, we'll have a "preset" of images too.

Currently, I'm adding the following structure in the toolbar:

  &lt;toolbaritem&gt;
    &lt;stack&gt;
      &lt;toolbarbutton /&gt;
      &lt;label top="-6" right="-6"&gt;
    &lt;/stack&gt;
  &lt;/toolbaritem&gt;

Not sure if there is a better way. If the "badge API" can't be added in `createWidget`, the "custom" type should be at least provide a nice way to create such component.</Description></bugID>